Subject: [Softwires] comments on draft-ietf-softwire-map-dhcp-04

From: Qi Sun <[email-masked]>
Date: Mon, 29 Jul 2013 16:45:20 +0200

Dear authors,

I have some observations on the new map-dhcp draft:

Sec 1, para 2

   Networks with numerous CEs require dynamic configuration of these
  parameters on CEs, which forms the requirement for a dynamic
  provisioning mechanism using DHCPv6 [RFC3315] options that are the
   subject of this document.

[Qi] The dynamic feature of DHCPv6 is for the management of IPv6 address/prefix, rather than for that of IPv4 address/port-set. And the subject of this document is, IMHO, assigning IPv4 address/port-set across IPv6 network using DHCPv6 options. It's also not the DHCPv6 server's job to dynamically manage the IPv4 address/port-set.

sec 3, bullet 1:
Key parameters of a BR include: i) The IPv4 Prefix - Used
      to derive the CE's IPv4 address; ii) The Embedded Address bit
      length - Used to derive how many, if any, of the CE's end-user
      IPv6 prefix are to be mapped to its IPv4 address and port-set.
      iii) The IPv6 prefix - used to scope the CE's IPv6 domain for the
      S46 service

[Qi] All these are for MAP. What lw4o6 needs are IPv6 address/prefix, IPv4 address and port set (optionally). The IPv6 address/prefix is assigned through normal DHCPv6 process, not through the newly defined option. So would it be helpful that we reflect that in this document?

Sec 6, bullet 3:
(0/0 IPv4 prefix) + (128 IPv6 prefix) ==> encapsulation mode
(0/0 IPv4 prefix) + (shorter than 128 IPv6 prefix) ==> translation mode
[Qi] What happens if the length of the IPv4 prefix is zero, while the content of IPv4 prefix is not 0.0.0.0?
My suggestion is once the length of the IPv4 prefix is zero, the CE SHOULD ignore the content of the IPv4 prefix. 

Sec 4.6, bullet 4
   o  The presence of a OPTION_S46_BRULE option indicates to the CE that
      NAPT44 mode of operation is to be used, and the conveyed A+P
      parameters applied.

[Qi] Does this mean no matter whether the CE is configured with a shared IPv4 address, NAT44 mode will be used anyway?

Sec 7:
This type of DHCP server and configuration store deployment
  is recommended when the intent is to utilize full IPv4-IPv6 address
   independence of any given CE, by issuing unique options to each CE.

[Qi] Port Parameters Option is actually a per-client option. This is true no matter whether the full IPv4-IPv6 address independence is needed. Length of PSID is a parameter shared by CEs in a domain. Maybe we need to clarify that?

More extensive than those possible by means of DHCPv6
  in conjunction with the options in this document, should consider the
  use of DHCPv4 over IPv6 as specified in
   [I-D.ietf-dhc-dhcpv4-over-ipv6].
[Qi] I think there should be a reference to dhcpv4-over-dhcpv6.

Nits:
sec 1, para 2
responsible for forwarding between an
   IPv6 network domain and external public IPv4 network,
=> an external public IPv4 network

S46 Port Parameters Option 
=> sub-option? Not sure
OPTION_S46__PORTPARAMS => OPTION_S46_PORTPARAMS

Best Regards,
Qi